---
layout: feature
title: "DevSecOps makes your applications more secure"
description: "How to use GitLab as a Security tool using SAST, DAST, Dependency & Container Scanning and License Management"
suppress_header: true
canonical_path: "/product/continuous-integration/"
extra_css:
  - gitlab-feature-landing-page.css
  - features.css
---
.wrapper.gitlab-ee-page
  .blank-header
    %img.image-border.image-border-left{ src: "/images/home/icons-pattern-left.svg" }
    %img.image-border.image-border-right{ src: "/images/home/icons-pattern-right.svg" }
    .header-content
      %img.hero-image-small{ src: "/images/devops-tools/gitlab-logo.svg" }
      %h1 DevSecOps with GitLab
      %p
        Continuous security testing within GitLab CI/CD
      %a.btn.cta-btn.orange{ href: "/free-trial/" } Try GitLab for Free
  .sub-wrapper
    .container
      .grid-layout.grid-layout2.margin-top50
        .grid-item
          %h2.margin-top0 Application Security
          %p
            %strong Application Security is hard when security is separated from your DevOps flow.
            Security has traditionally been the final hurdle in the development lifecycle. Iterative development workflows can make security a release bottleneck. Your team doesn't have enough people to test all of your code, and hiring more analysts won't automatically reduce the friction between your app sec and engineering teams.
            Only testing major releases, or limiting tests to certain apps, leaves weak spots hackers can exploit. You need a way to balance risk and business agility.
            Instead of waiting for security at the end of the development process, you can include it with your DevOps workflow. You need DevSecOps.
          %a.btn.cta-btn.orange.margin-top20{href: "/demo/"} Learn more
        .grid-item
          %iframe{:allow => "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture", :allowfullscreen => "", :frameborder => "0", :height => "315", :src => "https://www.youtube.com/embed/U2_dqwTRUVk", :width => "560"}
      %hr.divider

      .row.advantages
        .col-xs-1.col-md-1
        .col-xs-10.col-md-10
          %h2.margin-top0 What is DevSecOps?

          %p
            %strong DevSecOps
            integrates security best practices in the DevOps workflow. DevSecOps automates security workflows to create an adaptable process for your development and security teams.

          %h2 Why is DevSecOps needed?

          %p
            %strong Balancing business velocity
            with security is possible. With GitLab, DevSecOps architecture is built into the CI/CD process. Every merge request is scanned through its pipeline for vulnerabilities in your code and its dependencies. This enables some magic to happen:
        %hr.divider

      .row.advantages
        .col-xs-1.col-md-1
        .col-xs-10.col-md-10
          %h2.margin-top0 Benefits of DevSecOps
          %ul
            %li
              %strong Every piece of code
              is tested upon commit, without incremental cost.
            %li
              %strong The developer
              can remediate now, while they are still working in that code, or create an issue with one click.
            %li
              %strong The dashboard
              for the security pro is a roll-up of vulnerabilities remaining that the developer did not resolve on their own.
            %li
              %strong Vulnerabilities
              can be efficiently captured as a by-product of software development.
            %li
              %strong  A single tool
              also reduces cost over the approach to buy, integrate and maintain point solutions.
        .col-xs-10.col-md-10.col-md-offset-1
          %img{ alt: "CI/CD Overview", src: "/images/secure/securitydiagram.png", style: "margin-top: 40px;" }
      %hr.divider

      .row.advantages
        .col-xs-1.col-md-1
        .col-xs-10.col-md-10
          %h2 The GitLab Secure Paradigm
          %p
            %strong GitLab secure
            capabilities support the decision-makers. Instead of security being a blocker, we want to provide a very simple way to take the right action and learn from it. Keeping it simple is a key value so that security features will not be considered more effort than the perceived benefit. What is a false positive can be very subjective, and risk assessment will be mostly a human process. That's why we believe security features should not automatically block a pipeline or prevent a new version to be released to production. Key aspects of our design include:
            %ul
              %li
                %strong Reports
                are interactive, actionable, and iterative. When triaging vulnerabilities, users can confirm them (creating an issue to solve the problem), or dismiss them (in case they are false positives). This information will be collected to improve the signal-to-noise ratio that the tool could provide in future executions.
              %li
                %strong Easy-to-use
                reports need to require the minimum amount of effort from users. Otherwise, security checks will likely be disabled or not considered at all, missing their primary goal.
              %li
                %strong Unlike traditional application
                security tools primarily intended for use by security pros, GitLab secure capabilities are built into the CI/CD workflow where the developers live. We empower developers to identify vulnerabilities and remove them early, while at the same time, providing security pros a dashboard to view items not already resolved by the developer, across projects. This vulnerability-centric approach helps each role deal with items that are most important and also most relevant to their scope of work.

            Learn more about the GitLab Secure
            %a{ href: "https://gitlab.com/gitlab-com/www-gitlab-com/895ed1ec5fe0700c285eff5bef2377383c15cca9/direction/secure#security-paradigm" }
              Paradigm.
      %hr.divider

        .col-xs-10.col-md-10.col-md-offset-1

      .row.advantages
        .col-xs-1.col-md-1
        .col-xs-10.col-md-10
          %h2 What Are The GitLab Advantages?
          %ul
            %li
              %strong Supports users
              in prioritizing, managing, and solving security issues that affect their environment
            %li
              %strong Easy to learn:
              See our
              %a{ href: "https://www.youtube.com/watch?v=VR2r1TJCDew" }
                Quick Start
              guide on setting up GitLab
            %li
              %strong Support decision makers
              by giving a very simple way to take the right action, and learn from it.  Simplicity is a key value to prevent security features from not being considered due to complexity
            %li
              %strong Tools are actionable
              so users can interact with them and provide feedback about their content. When triaging vulnerabilities, users can confirm (creating an issue to solve the problem), or dismiss them (in case they are false positives and there is no further action to take).
            %li
              %strong Easy to use:
              Require the minimum amount of effort from users: We don't want to add extra workload on final users.
            %li
              %strong Shifting Security left:
              GiLab introduces security into the
              %a{ href: "/product/continuous-integration/" }
                CI/CD pipeline
              providing input on ONE application
        .col-xs-10.col-md-10.col-md-offset-1
          %h3{:align => "center"} Security Deep Dive
          %iframe{:allow => "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture", :allowfullscreen => "", :frameborder => "0", :height => "315", :src => "https://www.youtube.com/embed/k4vEJnGYy84", :width => "560"}

      %hr.divider
      .row.more-features
        .col-xs-1.col-md-1
        .col-xs-10.col-md-10
          %h2 Features
          %ul
            %li
              %strong Static Application Security Testing (SAST):
              Prevents
              %a{ href: "https://docs.gitlab.com/ee/user/project/merge_requests/sast.html" }
                vulnerabilities
              early in the development process, allowing to be fixed before deployment
            %li
              %strong Dynamic Application Security Testing (DAST):
              Once code is deployed,
              %a{ href: "https://docs.gitlab.com/ee/user/project/merge_requests/dast.html" }
                prevent
              exposure to your application from a new set of possible attacks as you are running your web applications
            %li
              %strong Dependency Scanning:
              Automatically finds security vulnerabilities in your
              %a{ href: "https://docs.gitlab.com/ee/user/project/merge_requests/dependency_scanning.html" }
                dependencies
              while you are developing and testing your applications, such as when you are using an external (open source) library with known vulnerabilities
            %li
              %strong Container Scanning:
              Analyze your
              %a{ href: "https://docs.gitlab.com/ee/user/project/merge_requests/license_management.html" }
                container
              images for known vulnerabilities
            %li
              %strong Auto Remediation:
              Auto
              %a{ href: "https://gitlab.com/groups/gitlab-org/-/epics/759" }
                remediation
              aims to automated vulnerability solution flow, and automatically create a fix. The fix is then tested, and if it passes all the tests already defined for the application, it is deployed to production.
            %li
              %strong Secret Detection, IAST and Fuzzing:
              Future features GitLab will be adding to its Security capabilities, see the visions for
              %a{ href: "https://gitlab.com/groups/gitlab-org/-/epics/675" }
                Secret Detection,
              %a{ href: "https://gitlab.com/groups/gitlab-org/-/epics/344" }
                IAST,
              %a{ href: "https://gitlab.com/groups/gitlab-org/-/epics/818" }
                and Fuzzing

        .col-xs-1.col-md-1
      %hr.divider
        %h1{:align => "center"} Continuous security testing within CI/CD
      %hr.divider
      .row
        .col-xs-12.col-md-6.col-md-offset-1
          %h2 Static Application Security Testing (SAST)
          %p
          %ul
            %li
              Scan the application source code and binaries to spot potential vulnerabilities.
            %li
              Because these open source tools are installed as part of GitLab Ultimate, there are no added costs.
            %li
              Vulnerabilities are shown in-line with every merge request and results are collected and presented as a single report.
            %li
              Evaluate vulnerabilities from the GitLab pipeline and dismiss or create an issue with one click.
        .hidden-xs.hidden-sm.col-md-4
          %img{alt: "Gitlab Static Application Security Testing", src: "/images/secure/sast-screen-shot.png", style: "margin-top: 150px;" }
      %hr.divider

      .row
        .hidden-xs.hidden-sm.col-md-4.col-md-offset-1
          %img.hidden-xs{alt: "Gitlab Dynamic Application Security Testing", src: "/images/secure/dast-findings-detail.png", style: "margin-top: 50px;" }
        .col-xs-12.col-md-6
          %h2 Dynamic Application Security Testing (DAST)
          %p
          %ul
            %li
              Dynamic scanning earlier in the SDLC than ever possible, by leveraging the review app CI/CD capability of GitLab.
            %li
              Test running web applications for known runtime vulnerabilities.
            %li
              Users can provide HTTP credentials to test private areas.
            %li
              Vulnerabilities are shown in-line with every merge request.
      %hr.divider

      .row
        .col-xs-12.col-md-6.col-md-offset-1
          %h2 Dependency Scanning
          %p
          %ul
            %li
              Analyze external dependencies (e.g. libraries like Ruby gems) for known vulnerabilities on each code commit with GitLab CI/CD.
            %li
              Identify vulnerable dependencies needing updating.
            %li
              Vulnerabilities are shown in-line with every merge request.
        .hidden-xs.hidden-sm.col-md-4
          %img{ alt: "GitLab Dependency Scanning", src: "/images/secure/dependency-findings-detail-full-screen.png", style: "margin-top: 50px;" }
      %hr.divider

      .row
        .hidden-xs.hidden-sm.col-md-4.col-md-offset-1
          %img.hidden-xs{ alt: "GitLab Container Scanning", src: "/images/secure/container-findings-detail.png", style: "margin-top: 50px;" }
        .col-xs-12.col-md-6
          %h2 Container Scanning
          %p
          %ul
            %li
              Check Docker images for known vulnerabilities in the application environment.
            %li
              Avoid redistribution of vulnerabilities via container images.
            %li
              Vulnerabilities are shown in-line with every merge request.
      %hr.divider

      .row
        .col-xs-12.col-md-6.col-md-offset-1
          %h2 License Management
          %p
          %ul
            %li
              Automatically search project dependencies for approved and blacklisted licenses defined by your policies.
            %li
              Custom license policies per project.
            %li
              License analysis results are shown in-line for every merge request for immediate resolution.
        .hidden-xs.hidden-sm.col-md-4
          %img{ alt: "GitLab License Management", src: "/images/secure/license-management-in-mr.png", style: "margin-top: 50px;" }
      %hr.divider

      .row.links
        .col-xs-1.col-md-1
        .col-xs-11.col-md-6
          %h2 Help and More Information
          %ul
            %li
              Please see
              %a{ href: "/get-help/" }
                Get help for GitLab
              if you have questions
            %li
              Security
              %a{ href: "https://youtu.be/U2_dqwTRUVk" }
                Dashboard demo
            %li
              Deep Dive into a
              %a{ href: "https://youtu.be/k4vEJnGYy84" }
                Security demo
            %li
              %a{ href: "https://docs.gitlab.com/ee//user/project/merge_requests/sast.html" }
                Static Application Security Testing
            %li
              %a{ href: "https://docs.gitlab.com/ee//user/project/merge_requests/dast.html" }
                Dynamic Application Security Testing
            %li
              %a{ href: "https://docs.gitlab.com/ee/user/project/merge_requests/dependency_scanning.html" }
                Dependency Scanning
            %li
              %a{ href: "https://docs.gitlab.com/ee//user/project/merge_requests/container_scanning.html" }
                Container Scanning
            %li
              %a{ href: "https://docs.gitlab.com/ee//user/project/merge_requests/license_management.html" }
                License Management
            %li
              See how
              %a{ href: "https://about.gitlab.com/2018/09/11/what-south-africa-taught-me-about-cybersecurity/" }
                integration
              is the key to successful DevSecOps
            %li
              See how we
              %a{ href: "https://docs.gitlab.com/ee//user/project/merge_requests/license_management.html" }
                compare
              against other Security tools
            %li
              Check out the
              %a{ href: "https://about.gitlab.com/webcast/monthly-release/gitlab-11.1---security" }
                11.1 Release
              radar with security level-set
        .hidden-xs.hidden-sm.col-md-4
          %img.gitlab-arch.hidden-xs{ alt: "GitLab Agile", src: "/images/logos/gitlab-logo.svg", style: "margin-top: 100px;" }
